 <!DOCTYPE html>
  <html lang="en">
    <head>
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width, initial-scale=1.0" />
      <title>My messages app</title>
     <script src="https://cdn-tailwindcss.vercel.app/"></script>
    </head>
    <body class="w-screen h-screen p-3">
        <div class="h-full grid grid-cols-4 gap-3">
            <div class="h-full rounded-xl bg-gray-100 p-3" id="user_list">
                <div class="text-sky-700 w-full text-center mb-1">
                    Hello
                    <b id="user_name"></b>
                </div>
            </div>
            <div class="h-full col-span-3 flex flex-col">
                <div class="flex-grow flex bg-gray-50 flex-col border-gray-100 border rounded-xl mb-3 px-2" id="message_list">
                    <div class="flex-grow"></div>
                    
                   
                </div>
                <input id="input_message" class="p-3 border-sky-700 border-2 rounded-xl " type="text" placeholder="Enter message here and press enter...">
            </div>
        </div>
    </body>

    <script>
        let credentials = {username: "", name: "", token: window.location.pathname.split(":")[1]}

        const source = new EventSource("/receive/tkn:"+credentials.token)
        source.onmessage = (event) => {
            const msg = JSON.parse(event.data);
            addMessage({username:msg.from, content: msg.content});
        }

        const getCredentials = () => {
            const userNameElement = document.getElementById("user_name");
            const req = new XMLHttpRequest();
            req.open('GET', '/whoami/tkn:'+credentials.token, false);
            req.send(null);
            if(req.status === 200) {
                console.log(req.response)
                const res = JSON.parse(req.responseText);
                credentials.username = res.username;
                credentials.name = res.name;
            }
            userNameElement.innerHTML += credentials.name
        }
        getCredentials();

        const messageListElement = document.getElementById("message_list");
        const userListElement = document.getElementById("user_list");

        const userList = [];

        let messageList = [];

        const addUser = (userid, username) => {
            userListElement.innerHTML += `<div onclick="setActive('usr_${userid}')" id="usr_${userid}" class="cursor-pointer p-3 mb-1.5 rounded-lg text-black hover:bg-sky-900 hover:text-white">${username}</div>`
        }

        let selectedUserId = "";

        const setActive = (userid) => {
            selectedUserId = userid.replaceAll("usr_", "");
            document.getElementById(userid).classList.add("bg-sky-800")
            document.getElementById(userid).classList.add("text-white")
            userList.forEach(user => {
                if ("usr_"+user.id !== userid) {
                    setInactive("usr_"+user.id);
                }
            });
            loadMessages(userid);
        }

        const setInactive = (userid) => {
            console.log(userid);
            document.getElementById(userid).classList.remove("bg-sky-800")
            document.getElementById(userid).classList.remove("text-white")
        }

        const initMessages = () => {
            messageListElement.innerHTML = "";
            messageListElement.innerHTML += `<div class="flex-grow"></div>`
            console.log(messageList);
            messageList.forEach(message => {
                addMessage(message)
            })
        }

        const addMessage = (message) => {
            console.log(message);
            if(message.username === credentials.username) {
                messageListElement.innerHTML += `<div class="ml-11 rounded-lg p-3 bg-sky-200 mb-2">${message.content}</div>` 
            } else {
                messageListElement.innerHTML += ` <div class="mr-11 rounded-lg p-3 bg-gray-200 mb-2">${message.content}</div>` 
            }
        }

        const input = document.getElementById("input_message");

        input.addEventListener("keyup", function(event) {
            if (event.keyCode === 13) {
                event.preventDefault();
                messageList.push(event.target.value);
                const message = {username: credentials.username, content: event.target.value}
                addMessage(message);
                input.value = "";
                sendMessage(message)
            }
        });

        const loadMessages = async (userid) => {
            // Load messages from server for this conversation. Can be done in synchronous way with await keyword
            messageList = [];
            // Don't touch after
            initMessages();
        }

        const sendMessage = async (message) => {
            console.log("Send message", message);
            const req = new XMLHttpRequest();
            req.open('POST', '/send_message/tkn:'+credentials.token+'/target:'+selectedUserId, false);
            req.send(JSON.stringify(message))
            if(req.status === 200) {
                console.log(req);
            }
        }

        const loadUsers = async () => {
            // Load user list from server. Can be done in synchronous way with await keyword
            const req = new XMLHttpRequest();
            req.open('GET', '/users', false);
            req.send(null);
            if(req.status === 200) {
                const res = JSON.parse(req.responseText);
                res.forEach(usr => {
                    if (usr.username !== credentials.username) {
                        userList.push({id:usr.username, name:usr.name});
                    }
                });
            }

            userList.forEach(user => {
                addUser(user.id, user.name);
            });
        }

        loadUsers();
        
    </script>
  </html>
